Subject: Re: The future of gitweb - part 2: JavaScript

From: Jakub Narebski <[email-masked]>
Date: Mon, 18 Apr 2011 16:15:13 +0200

On Mon, 18 Apr 2011, Petr Baudis wrote:
> On Mon, Apr 18, 2011 at 03:34:30PM +0200, Jakub Narebski wrote:
> > On Sun, 17 Apr 2011, Petr Baudis wrote:

> > >   Girocco uses MooTools, and I also used it in an old private branch
> > > of gitweb. I have had pretty good experience with it. But since I wasn't
> > > able to find anyone to maintain Girocco's gitweb (or even keep it in
> > > sync with upstream) and the patch flow to core git has dried up, it's
> > > probably not too relevant argument. :-)
> > 
> > Thanks.  The information about MooTools is certain helpful.
> > 
> > Do you remember why did you choose MooTools from other existing JavaScript
> > frameworks, including more popular jQuery?
> 
>   Unfortunately, it was few years back so I don't remember clearly
> anymore - it certainly was not a very educated guess, however, since I'm
> not really a JavaScript hacker. Possibly I just stumbled on a nicer
> guide for MooTools than jQuery at that time. By now, it's quite possible
> that jQuery is a friendlier alternative.

Well, I am also partial to MooTools.  I haven't examined all JavaScript
frameworks, or did examination in much detail, but from jQuery, MooTools
and YUI I think MooTools looks best.  jQuery looks a bit too little,
being mainly about DOM manipulation (though it has lots of plugins), YUI
being a bit too much (gitweb doesn't need and shouldn't need all this);
MooTools look about right (and has More and forge / plugins)... and is
second most popular after jQuery ;-)

But I'm willing to be persuaded.

What gitweb needs currently (meaning existing JavaScrip and patches
in flight):
 * support for old browsers that might not have findElementsByClassName
   of querySelectorAll
 * formatting Date in RFC2822-like format
 * event delegation (live events)
 * support for onprogress for XHR, emulated if necessary
 * attaching / detaching simple floating menu

References:
^^^^^^^^^^^
* http://jqueryvsmootools.com/ (by MooTools developer)
* http://stackoverflow.com/questions/394601/which-javascript-framework-jquery-vs-dojo-vs

-- 
Jakub Narebski
Poland